diff --git a/config/locales/ca.yml b/config/locales/ca.yml
index 52820b0e4..ef3f7ab85 100644
--- a/config/locales/ca.yml
+++ b/config/locales/ca.yml
@@ -358,7 +358,7 @@ ca:
   setting_issue_done_ratio_issue_field: "Utilitza el camp de la incidència"
   setting_start_of_week: "Inicia les setmanes en"
   setting_rest_api_enabled: "Habilita el servei web REST"
-  setting_cache_formatted_text: "Cache formatted text"
+  setting_cache_formatted_text: "Recorda el text formatat"
 
   permission_add_project: "Crear projecte"
   permission_add_subprojects: "Crear subprojectes"
@@ -1182,10 +1182,10 @@ ca:
   label_font_proportional: Font Proportional
   setting_timespan_format: Time span format
   label_table_of_contents: Taula de continguts
-  setting_commit_logs_formatting: Apply text formatting to commit messages
+  setting_commit_logs_formatting: Aplicar format de text als missatges de commit
   setting_mail_handler_enable_regex: Activar les expressions regulars
-  error_move_of_child_not_possible: 'Subtask %{child} could not be moved to the new
-    project: %{errors}'
+  error_move_of_child_not_possible: 'La subtasca %{child} no s''ha pogut moure al nou
+    projecte: %{errors}'
   error_cannot_reassign_time_entries_to_an_issue_about_to_be_deleted: El temps consumit no es pot reassignar
     a una incidència que està a punt d'eliminar-se
   setting_timelog_required_fields: Camps obligatoria per el registre de temps
@@ -1215,9 +1215,9 @@ ca:
   button_actions: Accions
   mail_body_lost_password_validity: Tingueu en compte que podeu canviar la contrasenya només un cop
     fent servir aquest enllaç.
-  text_login_required_html: When not requiring authentication, public projects and their
-    contents are openly available on the network. You can <a href="%{anonymous_role_path}">edit
-    the applicable permissions</a>.
+  text_login_required_html: Quan no es requereix autenticació, els projectes públics i el seu
+    contingut son visibles per tothom a la xarxa. Podeu <a href="%{anonymous_role_path}">editar
+    els permisos disponibles</a>.
   label_login_required_yes: 'Yes'
   label_login_required_no: No, permetre accés anonim als projectes públics
   text_project_is_public_non_member: Els projectes públics i el seu contingut son disponibles
@@ -1231,47 +1231,47 @@ ca:
   label_ldaps_warning: La recomanació es fer servir una connexió xifrada amb LDSPS amb verificació del certificat
     certificat per prevenir qualsevol manipulació durant el procés d'autenticació.
   label_nothing_to_preview: Res a previsualitzar
-  error_token_expired: This password recovery link has expired, please try again.
-  error_spent_on_future_date: Cannot log time on a future date
-  setting_timelog_accept_future_dates: Accept time logs on future dates
+  error_token_expired: Aquests enllaç de recuperació de contrasenya ha caducat, proveu-ho de nou.
+  error_spent_on_future_date: No es pot registrar temps en dates futures
+  setting_timelog_accept_future_dates: Accceptar registres de temps en dates futures
   label_delete_link_to_subtask: "Suprimir relació"
-  error_not_allowed_to_log_time_for_other_users: You are not allowed to log time
-    for other users
-  permission_log_time_for_other_users: Log spent time for other users
+  error_not_allowed_to_log_time_for_other_users: No podeu registrar temps dedicat
+    per altres usuaris
+  permission_log_time_for_other_users: Registrar el temps dedicat per altres usuaris
   label_tomorrow: demà
   label_next_week: la setmana vinent
   label_next_month: el mes vinent
-  text_role_no_workflow: No workflow defined for this role
-  text_status_no_workflow: No tracker uses this status in the workflows
-  setting_mail_handler_preferred_body_part: Preferred part of multipart (HTML) emails
+  text_role_no_workflow: No hi cap flux de treball definit per aquest rol
+  text_status_no_workflow: Cap tipus d'incidència fa servir aquest estat en els fluxes de treball
+  setting_mail_handler_preferred_body_part: Part preferida dels correus multipart (HTML)
   setting_show_status_changes_in_mail_subject: Mostrar els canvis d'estat de les incidències en l'assumpte
     de les notificacions per correu
   label_inherited_from_parent_project: Heretats del projecte pare
   label_inherited_from_group: Heretats del grup %{name}
-  label_trackers_description: Trackers description
-  label_open_trackers_description: View all trackers description
+  label_trackers_description: Descripció dels tipus d'incidència
+  label_open_trackers_description: Veure la descripció de tots els tipus d'incidència
   label_preferred_body_part_text: Text
   label_preferred_body_part_html: HTML
-  field_parent_issue_subject: Parent task subject
+  field_parent_issue_subject: Assumpte de la tasca pare
   permission_edit_own_issues: Editar les pròpies incidències
-  text_select_apply_tracker: Select tracker
+  text_select_apply_tracker: Seleccionar tipus d'incidència
   label_updated_issues: Incidències actualitzades
-  text_avatar_server_config_html: The current avatar server is <a href="%{url}">%{url}</a>.
-    You can configure it in config/configuration.yml.
-  setting_gantt_months_limit: Maximum number of months displayed on the gantt chart
-  permission_import_time_entries: Import time entries
-  label_import_notifications: Send email notifications during the import
-  text_gs_available: ImageMagick PDF support available (optional)
-  field_recently_used_projects: Number of recently used projects in jump box
-  label_optgroup_bookmarks: Bookmarks
-  label_optgroup_recents: Recently used
-  button_project_bookmark: Add bookmark
-  button_project_bookmark_delete: Remove bookmark
+  text_avatar_server_config_html: El servidor d'avatars actual és <a href="%{url}">%{url}</a>.
+    El podeu configurar a config/configuration.yml.
+  setting_gantt_months_limit: Nombre màxim de mesos mostrats en el diagrama de gantt
+  permission_import_time_entries: Importar entrades de temps
+  label_import_notifications: Enviar notificacions de correu durant la importació
+  text_gs_available: Suport de ImageMagick PDF disponible (opcional)
+  field_recently_used_projects: Nombre de projectes recents amb accés directe
+  label_optgroup_bookmarks: Preferits
+  label_optgroup_recents: Usats recentment
+  button_project_bookmark: Afegir preferit
+  button_project_bookmark_delete: Treure preferit
   field_history_default_tab: Pestanya per defecte de l'historic de la incidència
-  label_issue_history_properties: Property changes
+  label_issue_history_properties: Canvis de propietat
   label_issue_history_notes: Notes
   label_last_tab_visited: Última pestanya visitada
-  field_unique_id: Unique ID
+  field_unique_id: ID únic
   text_no_subject: sense assumpte
   setting_password_required_char_classes: Required character classes for passwords
   label_password_char_class_uppercase: lletres majuscules
@@ -1282,12 +1282,12 @@ ca:
   label_starts_with: comença amb
   label_ends_with: acaba amb
   label_issue_fixed_version_updated: Versió de destí al dia
-  setting_project_list_defaults: Projects list defaults
+  setting_project_list_defaults: Llista per defecte dels Projectes
   label_display_type: Mostrar resultats en
   label_display_type_list: Llista
   label_display_type_board: Taula
-  label_my_bookmarks: My bookmarks
-  label_import_time_entries: Import time entries
+  label_my_bookmarks: El meus preferits
+  label_import_time_entries: Importar entrades de temps
   field_toolbar_language_options: Code highlighting toolbar languages
   label_user_mail_notify_about_high_priority_issues_html: Informar-me també de les incidències
     with a priority of <em>%{prio}</em> or higher
@@ -1298,81 +1298,80 @@ ca:
     bloquejada al menys per una incidència oberta.
   notice_issue_not_reopenable_by_closed_parent_issue: Aquesta incidència no es pot reobrir perquè la incidència
     pare ja està tancada.
-  error_bulk_download_size_too_big: These attachments cannot be bulk downloaded because
-    the total file size exceeds the maximum allowed size (%{max_size})
-  setting_bulk_download_max_size: Maximum total size for bulk download
+  error_bulk_download_size_too_big: Aquests adjunts no es poden descarregar en lot perquè
+    la mida total excedeix el màxim permès (%{max_size})
+  setting_bulk_download_max_size: Mida màxima per descàrrega el lot
   label_download_all_attachments: Descarregar tots els fitxers
-  error_attachments_too_many: This file cannot be uploaded because it exceeds the maximum
-    number of files that can be attached simultaneously (%{max_number_of_files})
+  error_attachments_too_many: Aquest fitxer no es pot pujar perquè sobrepassa el nombre màxim
+    de fitxers que es poden adjuntar simultaniament (%{max_number_of_files})
   setting_email_domains_allowed: Dominis de correu permesos
   setting_email_domains_denied: Dominis de correu no permesos
   field_passwd_changed_on: Últim canvi de contrasenya
-  label_relations_mapping: Relations mapping
-  label_import_users: Import users
-  label_days_to_html: "%{days} days up to %{date}"
-  setting_twofa: Two-factor authentication
-  label_optional: optional
-  label_required_lower: required
-  button_disable: Disable
-  twofa__totp__name: Authenticator app
-  twofa__totp__text_pairing_info_html: Scan this QR code or enter the plain text key
-    into a TOTP app (e.g. <a href="https://support.google.com/accounts/answer/1066447">Google
+  label_relations_mapping: Mapa de les relacions
+  label_import_users: Importar usuaris
+  label_days_to_html: "%{days} dies fins %{date}"
+  setting_twofa: Autenticació de doble factor
+  label_optional: opcional
+  label_required_lower: obligatoria
+  button_disable: Desactivar
+  twofa__totp__name: App autenticador
+  twofa__totp__text_pairing_info_html: Escaneja aquest codi QR o entra la clau en text pla
+    a una app TOTP (p.ex. <a href="https://support.google.com/accounts/answer/1066447">Google
     Authenticator</a>, <a href="https://authy.com/download/">Authy</a>, <a href="https://guide.duo.com/third-party-accounts">Duo
-    Mobile</a>) and enter the code in the field below to activate two-factor authentication.
-  twofa__totp__label_plain_text_key: Plain text key
-  twofa__totp__label_activate: Enable authenticator app
-  twofa_currently_active: 'Currently active: %{twofa_scheme_name}'
-  twofa_not_active: Not activated
-  twofa_label_code: Code
-  twofa_hint_disabled_html: Setting <strong>%{label}</strong> will deactivate and unpair
-    two-factor authentication devices for all users.
-  twofa_hint_required_html: Setting <strong>%{label}</strong> will require all users
-    to set up two-factor authentication at their next login.
-  twofa_label_setup: Enable two-factor authentication
-  twofa_label_deactivation_confirmation: Disable two-factor authentication
-  twofa_notice_select: 'Please select the two-factor scheme you would like to use:'
-  twofa_warning_require: The administrator requires you to enable two-factor authentication.
-  twofa_activated: Two-factor authentication successfully enabled. It is recommended
-    to <a data-method="post" href="%{bc_path}">generate backup codes</a> for your account.
-  twofa_deactivated: Two-factor authentication disabled.
-  twofa_mail_body_security_notification_paired: Two-factor authentication successfully
-    enabled using %{field}.
-  twofa_mail_body_security_notification_unpaired: Two-factor authentication disabled
-    for your account.
-  twofa_mail_body_backup_codes_generated: New two-factor authentication backup codes
-    generated.
-  twofa_mail_body_backup_code_used: A two-factor authentication backup code has been
-    used.
-  twofa_invalid_code: Code is invalid or outdated.
-  twofa_label_enter_otp: Please enter your two-factor authentication code.
-  twofa_too_many_tries: Too many tries.
-  twofa_resend_code: Resend code
-  twofa_code_sent: An authentication code has been sent to you.
-  twofa_generate_backup_codes: Generate backup codes
-  twofa_text_generate_backup_codes_confirmation: This will invalidate all existing backup
-    codes and generate new ones. Would you like to continue?
-  twofa_notice_backup_codes_generated: Your backup codes have been generated.
-  twofa_warning_backup_codes_generated_invalidated: New backup codes have been generated.
-    Your existing codes from %{time} are now invalid.
-  twofa_label_backup_codes: Two-factor authentication backup codes
-  twofa_text_backup_codes_hint: Use these codes instead of a one-time password should
-    you not have access to your second factor. Each code can only be used once. It is
-    recommended to print and store them in a safe place.
-  twofa_text_backup_codes_created_at: Backup codes generated %{datetime}.
-  twofa_backup_codes_already_shown: Backup codes cannot be shown again, please <a data-method="post"
-    href="%{bc_path}">generate new backup codes</a> if required.
-  error_can_not_execute_macro_html: Error executing the <strong>%{name}</strong> macro
+    Mobile</a>) i entra el codi en el camp de sotat per activar l'autenticació amb doble factor.
+  twofa__totp__label_plain_text_key: Clau en text pla
+  twofa__totp__label_activate: Activar app autenticador
+  twofa_currently_active: 'Actualment actius<: %{twofa_scheme_name}'
+  twofa_not_active: Sense activar
+  twofa_label_code: Codi
+  twofa_hint_disabled_html: Configurar <strong>%{label}</strong> desactivarà i desaparellarà
+    l'autenticació de doble factor per tots els usuaris.
+  twofa_hint_required_html: Configurar <strong>%{label}</strong> requerirà que tots els usuaris
+    autenticació de doble factor en el pròxim login.
+  twofa_label_setup: Habilitar el doble factor
+  twofa_label_deactivation_confirmation: Desactivar el doble factor
+  twofa_notice_select: 'Indiqueu quin esquema de doble factor voleu fer servir:'
+  twofa_warning_require: L'administrador requereix que activeu el doble factor d'autenticació.
+  twofa_activated: Autenticació amb doble factor correctament habilitada. Recomanem
+    de <a data-method="post" href="%{bc_path}">generar codis de reserva</a> pel vostre compte.
+  twofa_deactivated: Doble factor deshablitat
+  twofa_mail_body_security_notification_paired: S'ha activat l'autenticació amb doble factor correctament
+    fent servir %{field}.
+  twofa_mail_body_security_notification_unpaired: S'ha desactivat el dobler factor
+    pel vostre compte.
+  twofa_mail_body_backup_codes_generated: S'han generat nous codis d'autenticació de
+    doble factor.
+  twofa_mail_body_backup_code_used: S'ha fet servir un codi de reserva de doble factor.
+  twofa_invalid_code: El codi és invalid o obsolet.
+  twofa_label_enter_otp: Entreu el codi de segon factor.
+  twofa_too_many_tries: Massa intents.
+  twofa_resend_code: Reenviar codi
+  twofa_code_sent: Us hem enviat un codi d'autenticació
+  twofa_generate_backup_codes: generar codis de reserva
+  twofa_text_generate_backup_codes_confirmation: Això invalidarà tots els codis de reserva
+    i en generaraà de nous. Voleu seguir?
+  twofa_notice_backup_codes_generated: Els codis de reserva s'han generat.
+  twofa_warning_backup_codes_generated_invalidated: S'han generat nous codis de reserva.
+    Els codis existents de %{time} ja no son vàlids.
+  twofa_label_backup_codes: Codis de reserva del segon factor
+  twofa_text_backup_codes_hint: Feu servir aquesta codis enlloc de una contrasenya única en cas
+    que no tingueu accés al vostre segon factor. Cada codi es pot fer servir només una vegada.
+    Recomanem imprimir-los i guardar-los en un lloc segur.
+  twofa_text_backup_codes_created_at: Codis de reserva generats %{datetime}.
+  twofa_backup_codes_already_shown: Els codis de reserva no es poden mostrar de nou<a data-method="post"
+    href="%{bc_path}">genereu nous codis si</a> és necessari.
+  error_can_not_execute_macro_html: Error executant la macro <strong>%{name}</strong> 
     (%{error})
-  error_macro_does_not_accept_block: This macro does not accept a block of text
-  error_childpages_macro_no_argument: With no argument, this macro can be called from
-    wiki pages only
-  error_circular_inclusion: Circular inclusion detected
-  error_page_not_found: Page not found
-  error_filename_required: Filename required
-  error_invalid_size_parameter: Invalid size parameter
-  error_attachment_not_found: Attachment %{name} not found
-  permission_delete_project: Delete the project
-  field_twofa_scheme: Two-factor authentication scheme
+  error_macro_does_not_accept_block: Aquesta macro no accept un bloc de text
+  error_childpages_macro_no_argument: Sense cap argument, aquesta macro només es pot cridar
+    des de pàgines de wiki
+  error_circular_inclusion: Detectada inclusió circular
+  error_page_not_found: Pàgina no trobada
+  error_filename_required: Nom de fitxer obligatori
+  error_invalid_size_parameter: Paràmetre de mida incorrecte
+  error_attachment_not_found: No s'ha trobat l'adjunt %{name}
+  permission_delete_project: Esborra el projecte
+  field_twofa_scheme: Esquem d'autenticació de doble factor
   text_user_destroy_confirmation: Esteu segurs que voleu eliminiar aquest usuari i totes les seves
     referències? Això no es pot desfer. Sovint, bloquejar un usuari en lloc d'eliminar-lo
     es millor solució. Per cofirmar, entreu el seu inici de sessió (%{login})
@@ -1468,10 +1467,10 @@ ca:
   label_has_been: ha sigut
   label_has_never_been: mai ha sigut
   label_changed_from: canviat de
-  label_issue_statuses_description: Issue statuses description
-  label_open_issue_statuses_description: View all issue statuses description
-  text_default_active_job_queue_changed: Default queue adapter which is well suited
-    only for dev/test changed
-  text_select_apply_issue_status: Select issue status
-  field_name_or_email_or_login: Name, email or login
+  label_issue_statuses_description: Descripció de l'estat de les incidències
+  label_open_issue_statuses_description: Veure totes les descpricions dels estats de les incidències
+  text_default_active_job_queue_changed: L'adaptador de cua per defecte només és adequat per
+     proves ha canviat
+  text_select_apply_issue_status: Marca l'estat de la incidència
+  field_name_or_email_or_login: Nom, correu o login
   label_option_auto_lang: auto
-- 
2.40.1