From 4d0cc48531f2e131bb29494eee209eb05f8a0f85 Mon Sep 17 00:00:00 2001
From: otegami <otegami@clear-code.com>
Date: Thu, 28 Mar 2024 16:21:47 +0900
Subject: Remove redundant ApplicationHelper inclusions

---
 test/helpers/custom_fields_helper_test.rb                     | 1 -
 test/helpers/projects_helper_test.rb                          | 1 -
 test/unit/lib/redmine/field_format/attachment_format_test.rb  | 1 -
 test/unit/lib/redmine/field_format/bool_format_test.rb        | 1 -
 test/unit/lib/redmine/field_format/enumeration_format_test.rb | 2 --
 test/unit/lib/redmine/field_format/field_format_test.rb       | 2 --
 test/unit/lib/redmine/field_format/list_format_test.rb        | 1 -
 test/unit/lib/redmine/field_format/numeric_format_test.rb     | 2 --
 test/unit/lib/redmine/wiki_formatting/macros_test.rb          | 1 -
 9 files changed, 12 deletions(-)

diff --git a/test/helpers/custom_fields_helper_test.rb b/test/helpers/custom_fields_helper_test.rb
index c6e2d6190..647aec491 100644
--- a/test/helpers/custom_fields_helper_test.rb
+++ b/test/helpers/custom_fields_helper_test.rb
@@ -20,7 +20,6 @@
 require_relative '../test_helper'
 
 class CustomFieldsHelperTest < Redmine::HelperTest
-  include ApplicationHelper
   include CustomFieldsHelper
   include ERB::Util
 
diff --git a/test/helpers/projects_helper_test.rb b/test/helpers/projects_helper_test.rb
index 5831127df..b3ca95e95 100644
--- a/test/helpers/projects_helper_test.rb
+++ b/test/helpers/projects_helper_test.rb
@@ -20,7 +20,6 @@
 require_relative '../test_helper'
 
 class ProjectsHelperTest < Redmine::HelperTest
-  include ApplicationHelper
   include ProjectsHelper
   include ERB::Util
   include Rails.application.routes.url_helpers
diff --git a/test/unit/lib/redmine/field_format/attachment_format_test.rb b/test/unit/lib/redmine/field_format/attachment_format_test.rb
index 8d1619782..b4291b214 100644
--- a/test/unit/lib/redmine/field_format/attachment_format_test.rb
+++ b/test/unit/lib/redmine/field_format/attachment_format_test.rb
@@ -21,7 +21,6 @@ require_relative '../../../../test_helper'
 require 'redmine/field_format'
 
 class Redmine::AttachmentFieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
   include Redmine::I18n
 
   fixtures :users
diff --git a/test/unit/lib/redmine/field_format/bool_format_test.rb b/test/unit/lib/redmine/field_format/bool_format_test.rb
index d8c3969a6..c55d4ed1b 100644
--- a/test/unit/lib/redmine/field_format/bool_format_test.rb
+++ b/test/unit/lib/redmine/field_format/bool_format_test.rb
@@ -21,7 +21,6 @@ require_relative '../../../../test_helper'
 require 'redmine/field_format'
 
 class Redmine::BoolFieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
   include Redmine::I18n
 
   def setup
diff --git a/test/unit/lib/redmine/field_format/enumeration_format_test.rb b/test/unit/lib/redmine/field_format/enumeration_format_test.rb
index a53c8fe7f..74a637fc4 100644
--- a/test/unit/lib/redmine/field_format/enumeration_format_test.rb
+++ b/test/unit/lib/redmine/field_format/enumeration_format_test.rb
@@ -21,8 +21,6 @@ require_relative '../../../../test_helper'
 require 'redmine/field_format'
 
 class Redmine::EnumerationFieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
-
   def setup
     User.current = nil
     set_language_if_valid 'en'
diff --git a/test/unit/lib/redmine/field_format/field_format_test.rb b/test/unit/lib/redmine/field_format/field_format_test.rb
index 0ea7aea2f..f71d83e34 100644
--- a/test/unit/lib/redmine/field_format/field_format_test.rb
+++ b/test/unit/lib/redmine/field_format/field_format_test.rb
@@ -20,8 +20,6 @@
 require_relative '../../../../test_helper'
 
 class Redmine::FieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
-
   def setup
     User.current = nil
     set_language_if_valid 'en'
diff --git a/test/unit/lib/redmine/field_format/list_format_test.rb b/test/unit/lib/redmine/field_format/list_format_test.rb
index bc26db757..4d373f229 100644
--- a/test/unit/lib/redmine/field_format/list_format_test.rb
+++ b/test/unit/lib/redmine/field_format/list_format_test.rb
@@ -21,7 +21,6 @@ require_relative '../../../../test_helper'
 require 'redmine/field_format'
 
 class Redmine::ListFieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
   include Redmine::I18n
 
   def setup
diff --git a/test/unit/lib/redmine/field_format/numeric_format_test.rb b/test/unit/lib/redmine/field_format/numeric_format_test.rb
index 2545c7943..9e624f309 100644
--- a/test/unit/lib/redmine/field_format/numeric_format_test.rb
+++ b/test/unit/lib/redmine/field_format/numeric_format_test.rb
@@ -21,8 +21,6 @@ require_relative '../../../../test_helper'
 require 'redmine/field_format'
 
 class Redmine::NumericFieldFormatTest < ActionView::TestCase
-  include ApplicationHelper
-
   fixtures :projects, :users, :issue_statuses, :enumerations,
            :trackers, :projects_trackers, :roles, :member_roles,
            :members, :enabled_modules
diff --git a/test/unit/lib/redmine/wiki_formatting/macros_test.rb b/test/unit/lib/redmine/wiki_formatting/macros_test.rb
index 73233cdb1..1355acef3 100644
--- a/test/unit/lib/redmine/wiki_formatting/macros_test.rb
+++ b/test/unit/lib/redmine/wiki_formatting/macros_test.rb
@@ -20,7 +20,6 @@
 require_relative '../../../../test_helper'
 
 class Redmine::WikiFormatting::MacrosTest < Redmine::HelperTest
-  include ApplicationHelper
   include ActionView::Helpers::TextHelper
   include ActionView::Helpers::SanitizeHelper
   include ERB::Util
-- 
2.34.1